# Copyright 1999-2015. Parallels IP Holdings GmbH. All Rights Reserved.
# -*- coding: utf-8; mode: python -*-
"""This module contains various constants related to PAM"""

ConfigurationFile      = '/etc/pam.conf'
ConfigurationDirectory = '/etc/pam.d'

KnownNonPasswordCheckers = [
    'pam_access.so',
    # 'pam_ccreds.so', # TODO: well, I'm really not sure about this one...
                       # basically it's auth. cache module
    'pam_chroot.so',
    'pam_console.so',
    'pam_cracklib.so',
    'pam_debug.so',
    'pam_deny.so', # the module itself isn't a password checker but
                   # it can signal that a password checker presents
    'pam_env.so',
    'pam_filter.so', # TODO: not sure about this one
    'pam_group.so',
    'pam_issue.so',
    'pam_lastlog.so',
    'pam_limits.so',
    #'pam_listfile.so',   # TODO: should we remove this and next one
    #'pam_localuser.so',  # from the list?
    'pam_mail.so',
    'pam_mkhomedir.so',
    'pam_motd.so',
    'pam_nologin.so',    # TODO: should we remove this one from the list?
    'pam_permit.so',   # the module itself isn't a password checker but
                       # it can signal that a password checker presents
    'pam_postgresok.so', # the laughful one :-)
    'pam_radius.so',   # hmm. this one *should* be a password checker but
                       # it's not, according to docs and sources
    #'pam_rhosts_auth.so',
    'pam_rootok.so',   # this one is too special to treat it as a password checker
    'pam_securetty.so', # the same is true for this one
    'pam_selinux.so',  # Well, well...
    'pam_shells.so',  # TODO: should we remove this??
    'pam_stack.so',  # obvious
    'pam_stress.so', # emm... this one doesn't check password :-)
    #'pam_succeed_if.so', # TODO: as for pam_listfile.so ...
    'pam_tally.so',
    'pam_time.so',
    #'pam_timestamp.so',  # TODO: as for pam_listfile.so ...
    'pam_warn.so',
    'pam_wheel.so', # as for pam_rootok.so
    'pam_xauth.so',
    'pam_uwtmp.so',
    'pam_pkcs11.so', # smartcard, unsure
    'pam_gnome_keyring.so', # gnome keyring
    ]

# these modules are known as password checkers
KnownPasswordCheckers = [
    'pam_unix.so',
    'pam_unux_auth.so', # the synonym
    'pam_unix2.so',  # SuSE
    'pam_pwdb.so',
    'pam_userdb.so',
    'pam_ldap.so',
    'pam_kerberosIV.so',
    'pam_krb5.so',
    'pam_krb5afs.so',
    'pam_opie.so',
    'pam_skey.so',
    'pam_ftp.so', # TODO: really?
    'pam_smb_auth.so',
    'pam_tcb.so',
    'pam_securityserver.so', # MacOSX
    ]

# TODO: decide if we should add system-specific modules
# conditionally (e.g. pam_securityserver.so)

KnownPasswordSetters = [
    'pam_unix.so',
    'pam_unix_password.so',
    'pam_unix2.so',
    'pam_tcb.so',
    'pam_netinfo.so',
    # Who *ELSE* knows where this Lord Farquad lives?
    ]

# is that true? ;-)
KnownNonPasswordSetters = KnownNonPasswordCheckers

